Loading...
Searching...
No Matches
BALL::KGreedyBondOrderStrategy Class Reference

`#include <BALL/STRUCTURE/BONDORDERS/KGreedyBondOrderStrategy.h>`

Inheritance diagram for BALL::KGreedyBondOrderStrategy:

## Classes

struct | Option
| Option names. More...
struct | Default

## Constant Definitions

float | greedy_atom_type_penalty_
float | greedy_bond_length_penalty_
Size | greedy_k_
vector< PartialBondOrderAssignment > | greedy_set_
Position | current_solution_
int | greedy_node_expansions_
| KGreedyBondOrderStrategy (AssignBondOrderProcessor *parent)
virtual | ~KGreedyBondOrderStrategy ()
virtual void | clear ()
virtual void | init ()
virtual bool | readOptions (const Options &options)
virtual void | setDefaultOptions ()
virtual boost::shared_ptr< BondOrderAssignment > | computeNextSolution ()

## Additional Inherited Members

| AStarBondOrderStrategy (AssignBondOrderProcessor *parent)
virtual | ~AStarBondOrderStrategy ()
Public Member Functions inherited from BALL::BondOrderAssignmentStrategy
| BondOrderAssignmentStrategy (AssignBondOrderProcessor *parent)
Public Attributes inherited from BALL::BondOrderAssignmentStrategy
AssignBondOrderProcessor * | abop
| Our parent processor.
PartialBondOrderAssignment::HEURISTIC_INDEX | heuristic_index_
| The chosen heuristic.
std::priority_queue< PartialBondOrderAssignment > | queue_
int | step_
| The priority queue.

## Detailed Description

K-Greedy algorithm for bond order assignment.

This class implements a K-Greedy approach for the bond order assignment problem that can be used by the AssignBondOrderProcessor . The implementation of this strategy is very similar to the AStar approach and much of its functionality can be reused. We thus derive from AStarBondOrderStrategy .

Definition at line 27 of file KGreedyBondOrderStrategy.h.

## Constructor & Destructor Documentation

## KGreedyBondOrderStrategy()

BALL::KGreedyBondOrderStrategy::KGreedyBondOrderStrategy | ( | AssignBondOrderProcessor * | parent | ) |

## ~KGreedyBondOrderStrategy()

virtual BALL::KGreedyBondOrderStrategy::~KGreedyBondOrderStrategy | ( |  | ) |

virtual

## Member Function Documentation

## clear()

virtual void BALL::KGreedyBondOrderStrategy::clear | ( |  | ) |

virtual

Reimplemented from BALL::AStarBondOrderStrategy.

Reimplemented in BALL::BranchAndBoundBondOrderStrategy.

## computeNextSolution()

virtual boost::shared_ptr< BondOrderAssignment > BALL::KGreedyBondOrderStrategy::computeNextSolution | ( |  | ) |

virtual

Reimplemented from BALL::AStarBondOrderStrategy.

Reimplemented in BALL::BranchAndBoundBondOrderStrategy.

## init()

virtual void BALL::KGreedyBondOrderStrategy::init | ( |  | ) |

virtual

Reimplemented from BALL::AStarBondOrderStrategy.

Reimplemented in BALL::BranchAndBoundBondOrderStrategy.

## readOptions()

virtual bool BALL::KGreedyBondOrderStrategy::readOptions | ( | const Options & | options | ) |

virtual

Reimplemented from BALL::AStarBondOrderStrategy.

Reimplemented in BALL::BranchAndBoundBondOrderStrategy.

## setDefaultOptions()

virtual void BALL::KGreedyBondOrderStrategy::setDefaultOptions | ( |  | ) |

virtual

Reimplemented from BALL::AStarBondOrderStrategy.

Reimplemented in BALL::BranchAndBoundBondOrderStrategy.

## Member Data Documentation

## current_solution_

Position BALL::KGreedyBondOrderStrategy::current_solution_

protected

Definition at line 72 of file KGreedyBondOrderStrategy.h.

## greedy_atom_type_penalty_

float BALL::KGreedyBondOrderStrategy::greedy_atom_type_penalty_

protected

Definition at line 65 of file KGreedyBondOrderStrategy.h.

## greedy_bond_length_penalty_

float BALL::KGreedyBondOrderStrategy::greedy_bond_length_penalty_

protected

Definition at line 66 of file KGreedyBondOrderStrategy.h.

## greedy_k_

Size BALL::KGreedyBondOrderStrategy::greedy_k_

protected

Definition at line 68 of file KGreedyBondOrderStrategy.h.

## greedy_node_expansions_

int BALL::KGreedyBondOrderStrategy::greedy_node_expansions_

protected

Definition at line 74 of file KGreedyBondOrderStrategy.h.

## greedy_set_

vector<PartialBondOrderAssignment> BALL::KGreedyBondOrderStrategy::greedy_set_

protected

Definition at line 70 of file KGreedyBondOrderStrategy.h.